# Keep Spectators Spectating
execute as @a[gamemode=spectator] at @s positioned over motion_blocking positioned ~ ~2 ~ unless entity @s[dy=999] run tp ~ ~-2 ~
execute as @a[gamemode=spectator] at @s unless entity @e[type=giant, distance=..80] run tp @s @e[type=giant, sort=nearest, limit=1]

# Check Spawned
execute on vehicle as @s[nbt={OnGround:1b}] if score #giantfresh lvlmc.temp matches 1 run data modify entity @s Invulnerable set value 0b
execute on vehicle as @s[nbt={Invulnerable:1b}] if score #giantfresh lvlmc.temp matches 1 run return fail
execute if score #giantfresh lvlmc.temp matches 1 run scoreboard players set #giantfresh lvlmc.temp 2


# Basics
execute store result bossbar giant_bossbar value on vehicle unless score #giantfresh lvlmc.temp matches 4 run data get entity @s Health
execute on vehicle at @s run bossbar set giant_bossbar players @a[distance=..100]
execute on vehicle at @s run data modify entity @s Fire set value 0s

# Despawn
execute unless predicate lvlmc:time_night on vehicle run tp 0 -1000 0
execute on vehicle at @s unless entity @a[distance=..70, gamemode=!spectator] run return run function lvlmc:mobs/giant/end/despawn


scoreboard players set @a lvlmc.temp 0
execute if score #difficulty lvlmc.temp matches 2.. as @a[distance=..100] if items entity @s weapon.* minecraft:totem_of_undying store result score @s lvlmc.temp run damage @s 1000 generic
tellraw @a[scores={lvlmc.temp=1}] {"translate": "lvlmc.boss.giant.totem_warning", "color": "red", "italic": true}

# Phase 1
## Target nearest player
scoreboard players set @s lvlmc.temp 1
execute on target run scoreboard players set @e[sort=nearest, tag=giant_brain] lvlmc.temp 0
damage @s[scores={lvlmc.temp=1}] 1 minecraft:generic_kill by @a[limit=1, sort=nearest]


## Melee
scoreboard players remove @s lvlmc.attack_delay 1
execute as @s[scores={lvlmc.attack_delay=..0}] store success score @s lvlmc.temp on target run damage @s[distance=..4] 8 mob_attack by @e[type=giant,sort=nearest,limit=1]
execute store result score @s lvlmc.temp2 run random value 1..2
execute as @s[scores={lvlmc.attack_delay=..0, lvlmc.temp=1, lvlmc.temp2=1}] on target run effect give @s poison 4 1

scoreboard players set @s[scores={lvlmc.attack_delay=..0, lvlmc.temp=1}] lvlmc.attack_delay 20


## Beam
execute if score #giantbeam lvlmc.attack_delay matches 21.. unless entity @a[distance=15.., gamemode=!creative, gamemode=!spectator] run scoreboard players set #giantbeam lvlmc.attack_delay 40
execute if score #giantbeam lvlmc.attack_delay matches 21.. run scoreboard players set #giantbeam lvlmc.ray_count 0
scoreboard players remove #giantbeam lvlmc.attack_delay 1
execute if score #giantbeam lvlmc.attack_delay matches 20 on vehicle positioned ^-1.5 ^1 ^4 anchored eyes facing entity @p[gamemode=!creative, gamemode=!spectator] eyes run function lvlmc:mobs/giant/attacks/beam/indicate
execute if score #giantbeam lvlmc.attack_delay matches ..0 on vehicle positioned ^-1.5 ^1 ^4 anchored eyes facing entity @e[tag=beamtarget, limit=1] eyes run function lvlmc:mobs/giant/attacks/beam/attack
execute if score #giantbeam lvlmc.attack_delay matches ..0 run kill @e[tag=beamtarget]
execute if score #giantbeam lvlmc.attack_delay matches ..0 run scoreboard players set #giantbeam lvlmc.attack_delay 60


## Setting values
execute on vehicle run attribute @s generic.movement_speed base set 0.29
execute unless score #giantfresh lvlmc.temp matches 4 on vehicle run data modify entity @s Invulnerable set value 0b



# Phase 2
execute store result score @s lvlmc.temp on vehicle run data get entity @s Health
execute unless score @s lvlmc.temp < #giantphases lvlmc.temp run return fail
execute if score #giantfresh lvlmc.temp matches 2 run tellraw @a[distance=..100] {"translate":"lvlmc.boss.giant.phase2", "color": "red"}
execute if score #giantfresh lvlmc.temp matches 2 run playsound minecraft:block.end_portal.spawn ambient @a ~ ~ ~ 100000 1.6
execute if score #giantfresh lvlmc.temp matches 2 run scoreboard players set #giantfresh lvlmc.temp 3


## Lightning Shock
scoreboard players add @e[tag=lightning_mark] lvlmc.attack_delay 1
execute as @e[tag=lightning_mark, scores={lvlmc.attack_delay=40..}] at @s as @a[distance=..3] run damage @s 50 minecraft:lightning_bolt
execute as @e[tag=lightning_mark, scores={lvlmc.attack_delay=40..}] at @s run summon lightning_bolt ~ ~-2 ~
execute as @e[tag=lightning_mark, scores={lvlmc.attack_delay=40..}] at @s run summon marker ~ ~ ~ {Tags:["earthquake_mark"], data:{distance:0}}
execute as @e[tag=lightning_mark, scores={lvlmc.attack_delay=40..}] run kill

scoreboard players remove #giantlightning lvlmc.attack_delay 1
execute if score #giantlightning lvlmc.attack_delay matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attack_delay matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attack_delay matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attack_delay matches 0 at @p run spreadplayers ~ ~ 25 25 false @e[tag=lightning_mark]
execute if score #giantlightning lvlmc.attack_delay matches 0 run execute as @e[tag=lightning_mark] at @s align xyz run tp ~ ~ ~
execute if score #giantlightning lvlmc.attack_delay matches ..0 store result score #giantlightning lvlmc.attack_delay run random value 160..240

execute at @e[tag=lightning_mark] run particle minecraft:electric_spark ~ ~ ~ 0 .4 0 0.5 20 force
execute at @e[tag=lightning_mark] run playsound minecraft:entity.allay.ambient_without_item master @a ~ ~ ~ 0.5 2
function lvlmc:mobs/giant/attacks/earthquake/init


## Barriers
scoreboard players add @e[tag=barrier_mark] lvlmc.attack_delay 1
execute as @e[tag=barrier_mark, scores={lvlmc.attack_delay=40}] at @s run summon lightning_bolt ~ ~-3 ~
execute as @e[tag=barrier_mark, scores={lvlmc.attack_delay=300..}] run kill

scoreboard players remove #giantbarriers lvlmc.attack_delay 1
execute if score #giantbarriers lvlmc.attack_delay matches 0 facing entity @p[gamemode=!creative, gamemode=!spectator] feet rotated ~ 0 positioned ^ ^ ^-50 run function lvlmc:mobs/giant/attacks/barrier/init with storage lvlmc:boss.giant
execute if score #giantbarriers lvlmc.attack_delay matches ..0 store result score #giantbarriers lvlmc.attack_delay run random value 700..800

execute at @e[tag=barrier_mark, scores={lvlmc.attack_delay=..39}] run particle minecraft:electric_spark ~ ~ ~ .3 .3 .3 0.5 30 force
execute at @e[tag=barrier_mark, scores={lvlmc.attack_delay=40..}] run particle minecraft:electric_spark ~ ~ ~ .3 5 .3 0.5 30 force
execute at @e[tag=barrier_mark, scores={lvlmc.attack_delay=40..}] as @a[dy=10] run damage @s 10 lightning_bolt
execute at @e[tag=barrier_mark, scores={lvlmc.attack_delay=40..}] run tag @a[dy=10] add damage_lightning
execute at @e[tag=barrier_mark, scores={lvlmc.attack_delay=..39}] run playsound minecraft:entity.allay.ambient_without_item master @a ~ ~ ~ 0.5 2


$execute store result score @a[tag=damage_lightning] lvlmc.electrocuted run data get storage lvlmc:boss.giant electrocute_time[$(difficulty)]
tag @a[tag=damage_lightning] remove damage_lightning


## Giant Minions
execute unless entity @e[tag=giant_minion] run scoreboard players remove #giantwaves lvlmc.attack_delay 1
execute if score #giantwaves lvlmc.attack_delay matches 0 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', CustomNameVisible:1b, Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}, {Name:"minecraft:generic.attack_damage", Base:10}], Tags:["giant_minion", "spread"], DeathLootTable:"lvlmc:entities/giant_minion"}
execute if score #giantwaves lvlmc.attack_delay matches 0 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', CustomNameVisible:1b, Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}, {Name:"minecraft:generic.attack_damage", Base:10}], Tags:["giant_minion", "spread"], DeathLootTable:"lvlmc:entities/giant_minion"}
execute if score #giantwaves lvlmc.attack_delay matches 0 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', CustomNameVisible:1b, Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}, {Name:"minecraft:generic.attack_damage", Base:10}], Tags:["giant_minion", "spread"], DeathLootTable:"lvlmc:entities/giant_minion"}
execute if score #giantwaves lvlmc.attack_delay matches 0 unless score #difficulty lvlmc.temp matches ..1 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', CustomNameVisible:1b, Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}, {Name:"minecraft:generic.attack_damage", Base:10}], Tags:["giant_minion", "spread"], DeathLootTable:"lvlmc:entities/giant_minion"}
execute if score #giantwaves lvlmc.attack_delay matches 0 unless score #difficulty lvlmc.temp matches ..2 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', CustomNameVisible:1b, Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}, {Name:"minecraft:generic.attack_damage", Base:10}], Tags:["giant_minion", "spread"], DeathLootTable:"lvlmc:entities/giant_minion"}
execute if score #giantwaves lvlmc.attack_delay matches 0 unless score #difficulty lvlmc.temp matches ..2 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', CustomNameVisible:1b, Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}, {Name:"minecraft:generic.attack_damage", Base:10}], Tags:["giant_minion", "spread"], DeathLootTable:"lvlmc:entities/giant_minion"}
execute if score #giantwaves lvlmc.attack_delay matches 0 run spreadplayers ~ ~ 5 20 false @e[tag=spread]
execute if score #giantwaves lvlmc.attack_delay matches 0 run tag @e[tag=spread] remove spread
execute if score #giantwaves lvlmc.attack_delay matches ..0 store result score #giantwaves lvlmc.attack_delay run random value 150..300

execute if entity @e[tag=giant_minion] on vehicle run data modify entity @s Invulnerable set value 1b
execute if entity @e[tag=giant_minion] on vehicle run attribute @s generic.movement_speed base set 0.2
execute unless entity @e[tag=giant_minion] run bossbar set giant_bossbar color green
execute if entity @e[tag=giant_minion] run bossbar set giant_bossbar color red


# Damage Giant
execute as @a[advancements={lvlmc:detection/giant_killed_minion=true}] store success score @s lvlmc.temp run damage @e[type=giant, limit=1, sort=nearest] 5 generic_kill
advancement revoke @a[scores={lvlmc.temp=1}] only lvlmc:detection/giant_killed_minion

# Phase 3
execute store result score @s lvlmc.temp on vehicle run data get entity @s Health
execute unless score @s lvlmc.temp < #giantphases lvlmc.temp2 run return fail


execute if score #giantfresh lvlmc.temp matches 3 run tellraw @a[distance=..100] {"translate":"lvlmc.boss.giant.phase3", "color": "red"}
execute if score #giantfresh lvlmc.temp matches 3 run playsound minecraft:block.end_portal.spawn ambient @a ~ ~ ~ 100000 1.6
execute if score #giantfresh lvlmc.temp matches 3 run tp @e[tag=giant_minion] 0 -100 0
$execute if score #giantfresh lvlmc.temp matches 3 store result score #giantfinal lvlmc.temp run data get storage lvlmc:boss.giant phase3_length[$(difficulty)]

execute if score #giantfresh lvlmc.temp matches 3 store result bossbar giant_bossbar value run scoreboard players get #giantfinal lvlmc.temp
execute if score #giantfresh lvlmc.temp matches 3 store result bossbar giant_bossbar max run scoreboard players get #giantfinal lvlmc.temp

execute if score #giantfresh lvlmc.temp matches 3 on vehicle run data modify entity @s Invulnerable set value 1b
execute if score #giantfresh lvlmc.temp matches 3 on vehicle run effect clear @s regeneration
execute if score #giantfresh lvlmc.temp matches 3 run scoreboard players set #giantfresh lvlmc.temp 4
weather thunder


execute if score #giantfinal lvlmc.temp matches ..0 on vehicle store result bossbar giant_bossbar max run attribute @s generic.max_health get
execute if score #giantfinal lvlmc.temp matches ..0 on vehicle run data remove entity @s HandItems[1]
execute if score #giantfinal lvlmc.temp matches ..0 run scoreboard players set #giantfresh lvlmc.temp 5

execute unless score #giantfinal lvlmc.temp matches ..0 run bossbar set giant_bossbar color red

execute unless score #giantfinal lvlmc.temp matches 1.. run return fail
execute store result bossbar giant_bossbar value run scoreboard players remove #giantfinal lvlmc.temp 1
scoreboard players set #giantlightning lvlmc.attack_delay -1
scoreboard players set #giantwaves lvlmc.attack_delay -1
scoreboard players set #giantbeam lvlmc.attack_delay -1


scoreboard players remove #giantlightning lvlmc.temp 1
execute if score #giantlightning lvlmc.temp matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.temp matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.temp matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.temp matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.temp matches 0 unless score #difficulty lvlmc.temp matches ..1 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.temp matches 0 at @p run spreadplayers ~ ~ 15 25 false @e[tag=lightning_mark]
execute if score #giantlightning lvlmc.temp matches 0 run execute as @e[tag=lightning_mark] at @s align xyz run tp ~ ~ ~
execute if score #giantlightning lvlmc.temp matches ..0 store result score #giantlightning lvlmc.temp run random value 60..100